using CadEditor;
using System;
using PluginMapEditor;
//css_include over_horizon/HorizonUtils.cs;
//css_include shared_settings/SharedUtils.cs;

public class Data 
{ 
  public string[] getPluginNames() 
  {
    return new string[] 
    {
      "PluginMapEditor.dll",
    };
  }
  public OffsetRec getScreensOffset()  { return new OffsetRec(0x46C9, 1 , 15*16, 15, 16);}
  public bool isBigBlockEditorEnabled() { return false; }
  public bool isBlockEditorEnabled()    { return true; }
  public bool isEnemyEditorEnabled()    { return false; }
  
  public OffsetRec getVideoOffset()   { return new OffsetRec(0x0, 1, 0x1000); }
  
  public bool isBuildScreenFromSmallBlocks() { return true; }
  
  public OffsetRec getBlocksOffset()    { return new OffsetRec(0xCC84, 1  , 0x1000);  }
  public int getBlocksCount()           { return 166; }
  public int getBigBlocksCount()        { return 166; }
  
  public GetVideoPageAddrFunc getVideoPageAddrFunc() { return SharedUtils.fakeVideoAddr(); }
  public GetVideoChunkFunc    getVideoChunkFunc()    { return SharedUtils.getVideoChunk(new[] {"ppu_dump_level_5_boss_1.bin"}); }
  public SetVideoChunkFunc    setVideoChunkFunc()    { return null; }
  public GetPalFunc           getPalFunc()           { return SharedUtils.readPalFromBin(new[] {"Pal_level_5_boss_1.bin"}); }
  public SetPalFunc           setPalFunc()           { return null;}
  
  public int getPalBytesAddr()         { return 0x54DF; }
  public bool getScreenVertical()      { return true; }
  

  public OffsetRec getPalOffset() { return new OffsetRec(0x0, 1  , 16  ); }
  
  public GetBlocksFunc getBlocksFunc() { return Utils.getBlocksLinear2x2withoutAttrib;}
  public SetBlocksFunc setBlocksFunc() { return Utils.setBlocksLinearWithoutAttrib;}
  
  //-------------------------------------------------------------------------------------------------------------------
  public MapInfo[] getMapsInfo()      { return HorizonUtils.makeMapsInfo(); }
  public LoadMapFunc getLoadMapFunc() { return HorizonUtils.loadMap; }
  public SaveMapFunc getSaveMapFunc() { return HorizonUtils.saveAttribsT; }
  public bool isMapReadOnly()         { return true; }
  public bool mapEditorSharePallete() { return true; }
  //-------------------------------------------------------------------------------------------------------------------
    
}